GELF_GETCAP(3)

NAME
gelf_getcap, gelf_update_cap - read and update ELF capability information

LIBRARY
libelf

SYNOPSIS
#include <gelf.h>
GElf_Cap *
gelf_getcap(Elf_Data *data, int ndx, GElf_Cap *cap);
int
gelf_update_cap(Elf_Data *data, int ndx, GElf_Cap *cap);

DESCRIPTION
These convenience functions are used to retrieve and update class-dependent Elf32_Cap or Elf64_Cap information.

Argument data is an Elf_Data descriptor associated with a section of type SHT_SUNW_cap. Argument ndx is the index of the entry being retrieved or updated. The class-independent GElf_Cap structure is described in gelf(3).

Function gelf_getcap() retrieves the class-dependent entry at index ndx in data buffer data and copies it to the destination pointed to by argument cap after translation to class-independent form.

Function gelf_update_cap() converts the class-independent entry pointed to by argument cap to class-dependent form, and writes it to the entry at index ndx in the data buffer described by argument data. Function gelf_update_cap() signals an error if any of the values in the class-independent representation exceeds the representable limits of the target type.

RETURN VALUES
Function gelf_getcap() returns the value of argument cap if successful, or NULL in case of an error. Function gelf_update_cap() returns a non-zero value if successful, or zero in case of an error.

ERRORS
These functions may fail with the following errors:

[ELF_E_ARGUMENT]
    Arguments data or cap were NULL.

[ELF_E_ARGUMENT]
    Argument ndx was less than zero or larger than the number of entries in the data descriptor.

[ELF_E_ARGUMENT]
    Data descriptor data was not associated with a section of type SHT_SUNW_cap.

[ELF_E_RANGE]
    A value was not representable in the target type.

SEE ALSO
elf(3), elf_getdata(3), elf_getscn(3), gelf(3)